<?php

/**
 * @file
 * 
 */

class views_handler_field_node_registration_available_slots extends views_handler_field_entity {

  function query() {
    views_handler_field_node_registration_used_slots::query();
  }

  function option_definition() {
    $options = parent::option_definition();

    $options += views_handler_field_node_registration_capacity::option_definition();
    return $options;
  }

  function options_form(&$form, &$form_state) {
    parent::options_form($form, $form_state);

    views_handler_field_node_registration_capacity::options_form($form, &$form_state);
  }

  function render($values) {
    if ($node = $this->get_value($values)) {
      $capacity = $node->registration->capacity();

      $values = (array) $values;
      $used_slots = (int) $values['registration_used_slots'];

      if (!$capacity && !$used_slots && !empty($this->options['unlimited_text'])) {
        return t($this->options['unlimited_text']);
      }

      $available_slots = max(0, $capacity - $used_slots);
      return $available_slots;
    }
  }

}
